(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@ng-bootstrap/ng-bootstrap'), require('moment-hijri'), require('moment'), require('@angular/forms'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-hijri-gregorian-datepicker', ['exports', '@angular/core', '@ng-bootstrap/ng-bootstrap', 'moment-hijri', 'moment', '@angular/forms', '@angular/common'], factory) :
    (global = global || self, factory(global['ngx-hijri-gregorian-datepicker'] = {}, global.ng.core, global.ngBootstrap, global.moment_, global.moment, global.ng.forms, global.ng.common));
}(this, (function (exports, i0, ngBootstrap, moment_, moment, forms, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    function __createBinding(o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    }
    function __exportStar(m, exports) {
        for (var p in m)
            if (p !== "default" && !exports.hasOwnProperty(p))
                exports[p] = m[p];
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (Object.hasOwnProperty.call(mod, k))
                    result[k] = mod[k];
        result.default = mod;
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    exports.NgxHijriGregorianDatepickerService = /** @class */ (function () {
        function NgxHijriGregorianDatepickerService() {
        }
        return NgxHijriGregorianDatepickerService;
    }());
    exports.NgxHijriGregorianDatepickerService.ɵprov = i0.ɵɵdefineInjectable({ factory: function NgxHijriGregorianDatepickerService_Factory() { return new exports.NgxHijriGregorianDatepickerService(); }, token: exports.NgxHijriGregorianDatepickerService, providedIn: "root" });
    exports.NgxHijriGregorianDatepickerService = __decorate([
        i0.Injectable({
            providedIn: 'root'
        })
    ], exports.NgxHijriGregorianDatepickerService);

    exports.NgxHijriGregorianDatepickerComponent = /** @class */ (function () {
        function NgxHijriGregorianDatepickerComponent() {
        }
        NgxHijriGregorianDatepickerComponent.prototype.ngOnInit = function () {
        };
        return NgxHijriGregorianDatepickerComponent;
    }());
    exports.NgxHijriGregorianDatepickerComponent = __decorate([
        i0.Component({
            selector: 'lib-ngx-hijri-gregorian-datepicker',
            template: "\n    <p>\n      ngx-hijri-gregorian-datepicker works!\n    </p>\n  "
        })
    ], exports.NgxHijriGregorianDatepickerComponent);

    var DateType = /** @class */ (function () {
        function DateType() {
        }
        return DateType;
    }());
    DateType.Hijri = 1;
    DateType.Gregorian = 2;

    var momentHijri = moment_;
    exports.DateFormatterService = /** @class */ (function () {
        function DateFormatterService(parserFormatter) {
            this.parserFormatter = parserFormatter;
        }
        DateFormatterService.prototype.ToString = function (date) {
            var dateStr = this.parserFormatter.format(date);
            return dateStr;
        };
        DateFormatterService.prototype.ToBindableHijroDate = function (hijriDate) {
            var hijriMomentDate = momentHijri(hijriDate, 'iD/iM/iYY HH:mm:ss tt'); // Parse a Hijri date.
            var day = hijriMomentDate.iDate();
            var month = +hijriMomentDate.iMonth() + 1;
            var year = hijriMomentDate.iYear();
            var ngDate = new ngBootstrap.NgbDate(+year, month, +day);
            return ngDate;
        };
        DateFormatterService.prototype.ToBindableHijroDateUsingFormat = function (hijriDate, format) {
            var hijriMomentDate = momentHijri(hijriDate, format); // Parse a Hijri date based on format.
            var day = hijriMomentDate.iDate();
            var month = +hijriMomentDate.iMonth() + 1;
            var year = hijriMomentDate.iYear();
            var ngDate = new ngBootstrap.NgbDate(+year, month, +day);
            return ngDate;
        };
        DateFormatterService.prototype.ToHijri = function (date) {
            if (!date) {
                return null;
            }
            var dateStr = this.ToString(date);
            var momentDate = momentHijri(dateStr, 'D/M/YYYY');
            var day = momentDate.iDate();
            var month = +momentDate.iMonth() + 1;
            var year = momentDate.iYear();
            var ngDate = new ngBootstrap.NgbDate(+year, month, +day);
            return ngDate;
        };
        DateFormatterService.prototype.ToGregorian = function (date) {
            if (!date) {
                return null;
            }
            var dateStr = this.ToString(date);
            var momentDate = momentHijri(dateStr, 'iD/iM/iYYYY');
            var day = momentDate.locale('en').format('D');
            var month = momentDate.locale('en').format('M');
            var year = momentDate.locale('en').format('Y');
            var ngDate = new ngBootstrap.NgbDate(+year, +month, +day);
            return ngDate;
        };
        return DateFormatterService;
    }());
    exports.DateFormatterService.ctorParameters = function () { return [
        { type: ngBootstrap.NgbDateParserFormatter }
    ]; };
    exports.DateFormatterService = __decorate([
        i0.Injectable()
    ], exports.DateFormatterService);

    var momentHijri$1 = moment_;
    exports.HijriGregorianDatepickerComponent = /** @class */ (function () {
        function HijriGregorianDatepickerComponent(dateFormatterService) {
            this.dateFormatterService = dateFormatterService;
            this.selectedDateType = DateType.Hijri;
            this.selectedDateChange = new i0.EventEmitter();
            this.readonly = false;
            this.isRequired = false;
            this.disabled = false;
        }
        Object.defineProperty(HijriGregorianDatepickerComponent.prototype, "DateType", {
            get: function () {
                return DateType;
            },
            enumerable: true,
            configurable: true
        });
        HijriGregorianDatepickerComponent.prototype.ngOnInit = function () {
        };
        HijriGregorianDatepickerComponent.prototype.getSelectedDate = function () {
            var formattedDate = this.dateFormatterService.ToString(this.selectedDate);
            if (this.selectedDateType == DateType.Hijri) {
                return momentHijri$1(formattedDate, 'iD/iM/iYYYY').locale('en').format();
            }
            if (this.selectedDateType == DateType.Gregorian) {
                return moment(formattedDate, 'D/M/YYYY').locale('en').format();
            }
        };
        HijriGregorianDatepickerComponent.prototype.dateSelected = function () {
            this.selectedDateChange.emit(this.selectedDate);
        };
        HijriGregorianDatepickerComponent.prototype.hijriClick = function () {
            if (this.selectedDateType == DateType.Hijri) {
                return;
            }
            this.selectedDateType = DateType.Hijri;
            //to hijri
            this.selectedDate = this.dateFormatterService.ToHijri(this.selectedDate);
            this.selectedDateChange.emit(this.selectedDate);
        };
        HijriGregorianDatepickerComponent.prototype.gregClick = function () {
            if (this.selectedDateType == DateType.Gregorian) {
                return;
            }
            this.selectedDateType = DateType.Gregorian;
            //to Gregorian
            this.selectedDate = this.dateFormatterService.ToGregorian(this.selectedDate);
            this.selectedDateChange.emit(this.selectedDate);
        };
        return HijriGregorianDatepickerComponent;
    }());
    exports.HijriGregorianDatepickerComponent.ctorParameters = function () { return [
        { type: exports.DateFormatterService }
    ]; };
    __decorate([
        i0.Input()
    ], exports.HijriGregorianDatepickerComponent.prototype, "selectedDate", void 0);
    __decorate([
        i0.Output()
    ], exports.HijriGregorianDatepickerComponent.prototype, "selectedDateChange", void 0);
    __decorate([
        i0.Input()
    ], exports.HijriGregorianDatepickerComponent.prototype, "label", void 0);
    __decorate([
        i0.Input()
    ], exports.HijriGregorianDatepickerComponent.prototype, "readonly", void 0);
    __decorate([
        i0.Input()
    ], exports.HijriGregorianDatepickerComponent.prototype, "isRequired", void 0);
    __decorate([
        i0.Input()
    ], exports.HijriGregorianDatepickerComponent.prototype, "disabled", void 0);
    __decorate([
        i0.Input()
    ], exports.HijriGregorianDatepickerComponent.prototype, "minHijri", void 0);
    __decorate([
        i0.Input()
    ], exports.HijriGregorianDatepickerComponent.prototype, "maxHijri", void 0);
    __decorate([
        i0.Input()
    ], exports.HijriGregorianDatepickerComponent.prototype, "minGreg", void 0);
    __decorate([
        i0.Input()
    ], exports.HijriGregorianDatepickerComponent.prototype, "maxGreg", void 0);
    exports.HijriGregorianDatepickerComponent = __decorate([
        i0.Component({
            selector: 'hijri-gregorian-datepicker',
            template: "\n    <div class=\"form-group\">\n      <label class=\"requiredInput\" for=\"input-birth-Date\">{{ label }} </label>\n\n      <div class=\"input-group\">\n\n          <input  class=\"form-control\"\n                  placeholder=\"d/M/yyyy\"\n                  [name]=\"label\"\n                  *ngIf=\"selectedDateType == DateType.Gregorian\"\n                  [(ngModel)]=\"selectedDate\"\n                  ngbDatepicker (click)=\"d.toggle()\"\n                  (dateSelect)=\"dateSelected()\"\n                  autocomplete=\"off\"\n                  #d=\"ngbDatepicker\"\n                  [readonly]=\"readonly\"\n                  [minDate]=\"minGreg\"\n                  [maxDate]=\"maxGreg\"\n                  [required]=\"isRequired\"\n                  [disabled]=\"disabled\">\n\n\n          <hijri-date-picker *ngIf=\"selectedDateType == DateType.Hijri\"\n                             [(selectedDate)]=\"selectedDate\"\n                             (selectedDateChange)=\"dateSelected()\"\n                             [readonly]=\"readonly\"\n                             [min]=\"minHijri\" [max]=\"maxHijri\"\n                             style=\"flex: 1 1 auto;\"\n                             [name]=\"label\"\n                             [isRequired]=\"isRequired\"\n                             [disabled]=\"disabled\">\n          </hijri-date-picker>\n\n          <div class=\"input-group-append\">\n                  <button class=\"btn btn-sm {{selectedDateType == DateType.Hijri ? 'btn-info focus active' :  'btn-outline-info'}}\" (click)=\"hijriClick()\"  [disabled]=\"disabled\" type=\"button\"> Hijri</button>\n                  <button class=\"btn btn-sm {{selectedDateType == DateType.Gregorian ? 'btn-info focus active' :  'btn-outline-info'}}\" (click)=\"gregClick()\" [disabled]=\"disabled\" type=\"button\">Gregorian</button>\n           </div>\n\n      </div>\n  </div>\n"
        })
    ], exports.HijriGregorianDatepickerComponent);

    var WEEKDAYS = ['أحد', 'إثنين', 'ثلاثاء', 'أربعاء', 'خميس', 'جمعة', 'سبت'];
    var MONTHS = ['محرم', 'صفر', 'ربيع الأول', 'ربيع الآخر', 'جمادى الأولى', 'جمادى الآخرة', 'رجب', 'شعبان', 'رمضان', 'شوال',
        'ذو القعدة', 'ذو الحجة'];
    exports.ɵb = /** @class */ (function (_super) {
        __extends(IslamicI18n, _super);
        function IslamicI18n() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        IslamicI18n.prototype.getWeekdayShortName = function (weekday) {
            return WEEKDAYS[weekday - 1];
        };
        IslamicI18n.prototype.getMonthShortName = function (month) {
            return MONTHS[month - 1];
        };
        IslamicI18n.prototype.getMonthFullName = function (month) {
            return MONTHS[month - 1];
        };
        IslamicI18n.prototype.getDayAriaLabel = function (date) {
            return date.day + "-" + date.month + "-" + date.year;
        };
        return IslamicI18n;
    }(ngBootstrap.NgbDatepickerI18n));
    exports.ɵb = __decorate([
        i0.Injectable()
    ], exports.ɵb);

    exports.ɵa = /** @class */ (function () {
        function HijriDatepickerComponent() {
            this.selectedDateChange = new i0.EventEmitter();
            this.readonly = false;
            this.isRequired = false;
            this.disabled = false;
        }
        HijriDatepickerComponent.prototype.changeDate = function () {
            this.selectedDateChange.emit(this.selectedDate);
        };
        HijriDatepickerComponent.prototype.onBlur = function () {
            if (!this.selectedDate) {
                this.selectedDateChange.emit(null);
            }
        };
        return HijriDatepickerComponent;
    }());
    __decorate([
        i0.Input()
    ], exports.ɵa.prototype, "selectedDate", void 0);
    __decorate([
        i0.Output()
    ], exports.ɵa.prototype, "selectedDateChange", void 0);
    __decorate([
        i0.Input()
    ], exports.ɵa.prototype, "readonly", void 0);
    __decorate([
        i0.Input()
    ], exports.ɵa.prototype, "isRequired", void 0);
    __decorate([
        i0.Input()
    ], exports.ɵa.prototype, "disabled", void 0);
    __decorate([
        i0.Input()
    ], exports.ɵa.prototype, "min", void 0);
    __decorate([
        i0.Input()
    ], exports.ɵa.prototype, "max", void 0);
    __decorate([
        i0.Input()
    ], exports.ɵa.prototype, "name", void 0);
    exports.ɵa = __decorate([
        i0.Component({
            selector: 'hijri-date-picker',
            template: "<input\n    class=\"form-control hijriInput\"\n    [(ngModel)]=\"selectedDate\"\n    placeholder=\"d/M/yyyy\"\n    ngbDatepicker\n    (click)=\"d.toggle()\"\n    (dateSelect)=\"changeDate()\"\n    #d=\"ngbDatepicker\"\n    [readonly]=\"readonly\"\n    [minDate]=\"min\"\n    [maxDate]=\"max\"\n    [required]=\"isRequired\"\n    [name]=\"name\"\n    (blur)=\"onBlur()\"\n    [disabled]=\"disabled\" />\n",
            providers: [
                { provide: ngBootstrap.NgbCalendar, useClass: ngBootstrap.NgbCalendarIslamicUmalqura },
                { provide: ngBootstrap.NgbDatepickerI18n, useClass: exports.ɵb }
            ],
            encapsulation: i0.ViewEncapsulation.None,
            styles: [".hijriInput{border-bottom-left-radius:0;border-top-left-radius:0}.ngb-dp-weekday{width:2.1rem!important}"]
        })
    ], exports.ɵa);

    var CustomNgbDateParserFormatter = /** @class */ (function (_super) {
        __extends(CustomNgbDateParserFormatter, _super);
        function CustomNgbDateParserFormatter(dateFormatString) {
            var _this = _super.call(this) || this;
            _this.dateFormatString = dateFormatString;
            _this.datePipe = new common.DatePipe('en-US');
            return _this;
        }
        CustomNgbDateParserFormatter.prototype.format = function (date) {
            if (date === null) {
                return '';
            }
            try {
                return this.datePipe.transform(new Date(date.year, date.month - 1, date.day), this.dateFormatString);
            }
            catch (e) {
                return '';
            }
        };
        CustomNgbDateParserFormatter.prototype.parse = function (value) {
            var returnVal;
            if (!value) {
                returnVal = null;
            }
            else {
                try {
                    var dateParts = this.datePipe.transform(value, 'M-d-y').split('-');
                    returnVal = { year: parseInt(dateParts[2]), month: parseInt(dateParts[0]), day: parseInt(dateParts[1]) };
                }
                catch (e) {
                    returnVal = null;
                }
            }
            return returnVal;
        };
        return CustomNgbDateParserFormatter;
    }(ngBootstrap.NgbDateParserFormatter));

    exports.NgxHijriGregorianDatepickerModule = /** @class */ (function () {
        function NgxHijriGregorianDatepickerModule() {
        }
        return NgxHijriGregorianDatepickerModule;
    }());
    exports.NgxHijriGregorianDatepickerModule = __decorate([
        i0.NgModule({
            declarations: [exports.NgxHijriGregorianDatepickerComponent,
                exports.HijriGregorianDatepickerComponent,
                exports.ɵa],
            imports: [
                common.CommonModule,
                forms.FormsModule,
                ngBootstrap.NgbModule
            ],
            providers: [
                exports.DateFormatterService,
                {
                    provide: ngBootstrap.NgbDateParserFormatter, useFactory: function () {
                        return new CustomNgbDateParserFormatter('d/M/yyyy');
                    }
                }
            ],
            exports: [exports.HijriGregorianDatepickerComponent, exports.NgxHijriGregorianDatepickerComponent]
        })
    ], exports.NgxHijriGregorianDatepickerModule);

    /*
     * Public API Surface of ngx-hijri-gregorian-datepicker
     */

    /**
     * Generated bundle index. Do not edit.
     */

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-hijri-gregorian-datepicker.umd.js.map
